/*
  ---------------------Electrophoresis------------------------------------------------------------

  This program will control the duration of the electrophoresis

  --------------------Usage guide----------------------------------------------------------------

  Program the arduino and mount the circuit. The circuit is on the following link:
  The gate of the mosfet is atcched to digital pin 3.
  
  Make sure that all components are in the right place and well conected.

  Open the serial monitor at 9600 baud.

  Change the value of the variable "minutes" to set the duration of the electrophoresis.

  created 2016
  by Fernando Nóbel Santos Navarro <fersann1@upv.es>

  This example code is in the public domain.

*/
int pinPowerSource = 3;
int minutes = 90; // time in minutes will last the electrophoresis
boolean stateON = false; //This var will change to true when the electrophoresis start
unsigned long start;
unsigned long electrophoresis__MS; // Duration of the electrophoresis in miliseconds

void setup() {
  // put your setup code here, to run once:
  pinMode(pinPowerSource, OUTPUT);
  digitalWrite(pinPowerSource, LOW);
  Serial.begin(9600);
  electrophoresis__MS = minutes * 60 * 1000;
  Serial.println("Introduce 1 to start electrophoresis.");
}

void loop() {
  // put your main code here, to run repeatedly:
  if ( (Serial.available() >= 1) && (stateON == false) )
  {
    if (Serial.parseInt() == 1)
    {
      stateON = true;
      start = millis();
      digitalWrite(pinPowerSource, HIGH);
      Serial.print("Electrophoresis is started it will last ");
      Serial.print(minutes);
      Serial.println(" minutes.")
    }
  }
  if (stateON == true) {
    if ( (millis() - start) > electrophoresis__MS) {
      stateON = false;
      digitalWrite(pinPowerSource, LOW);
      Serial.println("Electrophoresis is finished.");
      Serial.println("Introduce 1 to start electrophoresis.");
    }
    if ( ((millis() - start) % (60 * 10000))==0 ) {
      Serial.print( (int) minutes - (millis() - start)/(60*1000) );
      Serial.println(" minutes remaining");
    }
  }
}
